# Difference between revisions of "Dijkstra's algorithm"

m (→Implementation) |
m (categorize) |
||

Line 26: | Line 26: | ||

dist[w] = min(dist[w],dist[v]+wt(v,w)) | dist[w] = min(dist[w],dist[v]+wt(v,w)) | ||

</pre> | </pre> | ||

+ | |||

+ | [[Category:Algorithms]] |

## Revision as of 17:18, 23 December 2009

**Dijkstra's algorithm** finds single-source shortest paths in a directed graph with non-negative edge weights. (When negative-weight edges are allowed, the Bellman–Ford algorithm must be used instead.) It is the algorithm of choice for solving this problem, because it is easy to understand, relatively easy to code, and, so far, the fastest algorithm known for solving this problem in the general case. In sparse graphs, running it once on every vertex to generate all-pairs shortest paths is faster than solving the same problem with the Floyd–Warshall algorithm. (The precise time complexity of Dijkstra's depends on the nature of the data structures used; read on.)

# Theory of the algorithm

Dijkstra's may be characterized as a greedy algorithm, which builds the shortest-paths tree one edge at a time, adding vertices in non-decreasing order of their distance from the source. That is, in each step of the algorithm, we will find the next-closest vertex to the source. (If there is a tie, it does not matter which one is chosen.) We assume below that all nodes are reachable from the source. (If you find the two sections below too difficult, skip them.)

## Lemma

Suppose that we are given a set of vertices, containing the source *s*. We shall call a path *admissible* if it starts at *s*, proceeds through a sequence of vertices contained within , and ends with a single non- vertex. We claim that there exists an admissible path such that no other path from *s* to a non- vertex is shorter.

*Proof*: This consists of nothing but a series of observations. First, any path from *s* to a vertex *v* outside contains at least one edge from a vertex in to one outside, since *s* ∈ . Second, if the first such edge encountered along the path from *s* is not the last edge in the path, we can "cut off" the path at that point to obtain a path from *s* out of that is not longer (since all edges have non-negative weights). Third, if the sub-path from *s* to the last vertex in , denoted *u*, is not itself a shortest path from *s* to *u*, the length of the whole path may be decreased by substituting a shortest path from *s* to *u* for the current one. Now, suppose the opposite of what we want to prove: the shortest path from *s* out of , or all the shortest paths from *s* out of , is/are inadmissible. Then we may construct an admissible path using the three observations above which is not longer, a contradiction.

## The algorithm

The preceding Lemma should give us an idea of how to proceed. We start with only the source vertex in the shortest-paths tree ( is merely the vertex set of the partial shortest-paths tree); its distance to itself is obviously zero. Then, we repeatedly apply the Lemma by considering all admissible paths and finding the shortest. To do this we consider all edges that lead from a vertex *u* to a non- vertex *v*. Concatenating the *s*-*u* shortest path and the *u*-*v* edge yields an admissible path whose length is the sum of the length of the already-known *s*-*u* path and the weight of the *u*-*v* edge. The edge and vertex *v* at the very end of the shortest admissible path are added to the shortest-paths tree (and thus *v* is added to ); as no path from *s* to a non- vertex can be shorter, we are justified in claiming that *v* is the closest non- vertex to *s*, and that its distance from *s* is the shortest obtainable from an admissible path currently. This method of extending the shortest-paths tree by one vertex is repeated until all vertices have been added, and induction proves the algorithm's validity.

# Implementation

As the previous sections are a bit heavy, here is some pseudocode for Dijkstra's algorithm:

input G,s for each v ∈ V(G) let dist[v] = ∞ let dist[s] = 0 let T = ∅ while T ≠ V(G) let v ∈ V(G)\T such that dist[v] is minimal add v to T for each w ∈ V(G) such that (v,w) ∈ E(G) dist[w] = min(dist[w],dist[v]+wt(v,w))